"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const Delimiters = require("../tokens/delimiters");
const Keywords = require("../tokens/keywords");
const TypeReferenceTokens = require("../tokens/type_reference_tokens");
const GenericTokens = require("../tokens/generic_tokens");
const MethodParameterTokens = require("../tokens/method_parameter_tokens");
const ModifierTokens = require("../tokens/modifier_tokens");
const AttributeEmitter = require("./attribute_emitter");
function emit(writer, delegate) {
    const { attributes, access, result, name, generics, parameters } = delegate;
    AttributeEmitter.emitMany(writer, attributes);
    writer
        .outputTabs()
        .write(...ModifierTokens.forAccess(access))
        .write(Keywords.delegate, Delimiters.space)
        .write(...TypeReferenceTokens.emit(result))
        .write(Delimiters.space)
        .write(name)
        .write(...GenericTokens.emit(generics))
        .write(...MethodParameterTokens.emit(parameters))
        .write(Delimiters.semicolon)
        .writeLineNoTabs();
}
exports.emit = emit;
