"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const Delimiters = require("../tokens/delimiters");
const Signs = require("../tokens/signs");
const TypeReferenceTokens = require("../tokens/type_reference_tokens");
const ModifierTokens = require("../tokens/modifier_tokens");
const AttributeEmitter = require("./attribute_emitter");
function emit(writer, field) {
    const { access, isNew, isStatic, assignment, type, name, value } = field;
    const resultTokens = [...TypeReferenceTokens.emit(type), Delimiters.space];
    const valueTokens = value != null ? [Delimiters.space, Signs.equal, Delimiters.space, value] : [];
    emitAttributes(writer, field);
    writer
        .outputTabs()
        .write(...ModifierTokens.forAccess(access))
        .write(...ModifierTokens.forNew(isNew))
        .write(...ModifierTokens.forStatic(isStatic))
        .write(...ModifierTokens.forAssignment(assignment))
        .write(...resultTokens)
        .write(name)
        .write(...valueTokens)
        .write(Delimiters.semicolon)
        .writeLineNoTabs();
}
exports.emit = emit;
function emitAttributes(writer, field) {
    const { attributes } = field;
    AttributeEmitter.emitMany(writer, attributes);
}
