"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const ArrayUtils = require("../utils/array_utils");
const Delimiters = require("./delimiters");
const TypeReferenceTokens = require("./type_reference_tokens");
const Parentheses = require("./parentheses");
function emit(parameters) {
    const parameterTokens = ArrayUtils.isFalsy(parameters) ? ArrayUtils.empty() : precursors(parameters);
    return Parentheses.enclose(parameterTokens);
}
exports.emit = emit;
function precursors(parameters) {
    return parameters
        .map(p => precursor(p))
        .flatMap((g, i, arr) => i === arr.length - 1 ? g : [...g, Delimiters.comma, Delimiters.space]);
}
function precursor(parameter) {
    const { type, name } = parameter;
    return [...TypeReferenceTokens.emit(type), Delimiters.space, name];
}
