"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const NullableTokens = require("./nullable_tokens");
const NamespaceTokens = require("./namespace_tokens");
const GenericTokens = require("./generic_tokens");
function emit(reference) {
    if (reference === "void")
        return ["void"];
    const { namespace, name, nullable, generics } = reference;
    const namespaceTokens = NamespaceTokens.emit(namespace, true);
    const nullableTokens = NullableTokens.emit(nullable);
    const genericTokens = GenericTokens.emit(generics);
    return [...namespaceTokens, name, ...nullableTokens, ...genericTokens];
}
exports.emit = emit;
